"""Remove unique constraint for TaskStatus.is_default

Revision ID: 05ac7e8caa21
Revises: 0cf5e0e035fa
Create Date: 2022-06-16 14:26:54.695564

"""
from alembic import op
from sqlalchemy import orm
from zou.app.models.task_status import TaskStatus


# revision identifiers, used by Alembic.
revision = "05ac7e8caa21"
down_revision = "0cf5e0e035fa"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index("ix_task_status_is_default", table_name="task_status")
    op.create_index(
        op.f("ix_task_status_is_default"),
        "task_status",
        ["is_default"],
        unique=False,
    )
    # ### end Alembic commands ###

    # set all the TaskStatus.is_default == None to False
    bind = op.get_bind()
    session = orm.Session(bind=bind)
    task_statuses = (
        session.query(TaskStatus).filter(TaskStatus.is_default == None).all()
    )
    for task_status in task_statuses:
        task_status.is_default = False

    session.commit()


def downgrade():
    bind = op.get_bind()
    session = orm.Session(bind=bind)
    task_statuses = (
        session.query(TaskStatus).filter(TaskStatus.is_default == False).all()
    )
    for task_status in task_statuses:
        task_status.is_default = None

    session.commit()
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f("ix_task_status_is_default"), table_name="task_status")
    op.create_index(
        "ix_task_status_is_default",
        "task_status",
        ["is_default"],
        unique=False,
    )
    # ### end Alembic commands ###
