"""drop column TaskType.for_shots

Revision ID: 0cf5e0e035fa
Revises: f874ad5e898a
Create Date: 2022-06-10 13:34:48.830690

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy import orm
from zou.app.models.task_type import TaskType
from zou.app import db


# revision identifiers, used by Alembic.
revision = "0cf5e0e035fa"
down_revision = "f874ad5e898a"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###

    class oldTaskType(TaskType):
        for_shots = db.Column(db.Boolean, default=False)  # deprecated

    bind = op.get_bind()
    session = orm.Session(bind=bind)
    task_types = session.query(oldTaskType).all()
    for task_type in task_types:
        if task_type.for_shots and task_type.for_entity != "Shot":
            task_type.for_entity = "Shot"
    session.commit()
    op.drop_column("task_type", "for_shots")
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "task_type",
        sa.Column(
            "for_shots", sa.BOOLEAN(), autoincrement=False, nullable=True
        ),
    )
    # ### end Alembic commands ###
